<?php

/**
 * Author Oleg Isaev
 * E-mail: vazaxx@gmail.com
 * VK: vk.com/id50416641
 * Skype: pandcar97
 */

// ====== Примеры использования: ====== //

// №1
$prep = mysql_prepared('SELECT * FROM `user` WHERE `nick` = ? AND `money` = ? LIMIT ?');
$result = $prep->execute(['Pavel', 123, 5]);

// №2
$result = mysql_prepared('SELECT * FROM `user` WHERE `nick` = ? AND `money` = ? LIMIT ?')->execute(['Pavel', 123, 5]);

while ($row = mysql_fetch_assoc($result))
{
	// ...
}

// ====== Функции: ====== //

class SQLPrepared
{
	protected $sql = '';
	
	public function __construct($string)
	{
		$prc = 1;
		$this->sql = preg_replace_callback(
			'/\?/is', 
			function($matches) use (&$prc){
				return '?'.$prc++;
			}, 
			str_replace('"', "'", $string)
		);
	}
	
	public function execute($array)
	{
		$trans = [];
		$i = 1;
		
		foreach ($array as $value)
		{
			if (gettype($value) == 'integer' || preg_match('/^[0-9]{1,15}$/', strval($value)))
			{
				$trans['?'.$i] = intval($value);
			}
			else
			{
				$trans['?'.$i] = "'".addslashes(strval($value))."'";
			}
			
			$i++;
		}
		
		return mysql_query(strtr($this->sql, $trans));
	}
}

function mysql_prepared($query)
{
	return new SQLPrepared($query);
}

?>